module MetaRPC
  class ResponseWrapper
    def initialize(response)
      @response = response
    end

    def enforce_correct_value
      raise RpcClientError.new(@response[:error]), "#{@response[:error][:code]} #{@response[:error][:message]}" if @response.key?(:error)
    end

    def value
      enforce_correct_value
      @response[:result]
    end

    def [](key)
      value[key]
    end
  end
end
